<template>
	<div class="matrix-recap">
		<div class="flex space">
			<h3 class="hustle medium row-padding col-padding lightorange-color">Matrix</h3>
			<tutorial-icon color="#FFC233" @clicked="setTutorial('matrix_recap_info', -1, true)"/>
		</div>
		
		<div class="wrapper col-padding">
			<div class="timeline" ref="timeline">
				<div 
					class="timezone" 
					v-for="(nodes, timezone)  in node_by_matrix" 
					:class="{current : current_timezone == timezone, past : current_timezone > timezone}"
				>
					<div class="time" :ref="timezone">{{timezone}}</div>
					<div class="nodes">
						<a class="node" :class="{completed : completed_today[node.data.host]}"
							v-for="node in nodes" 
							target="_blank" 
							v-on:mouseover="nodeOver($event, node)"
							v-on:mouseleave="nodeLeave"
							:href="'http://'+node.data.host"
							:ref="node.id"
						>
							<svg xmlns="http://www.w3.org/2000/svg" width="80" height="80"  viewBox="-2 -2 84 84">
								<defs>
									<filter id="box-shadow" filterUnits="userSpaceOnUse">
										<feOffset result="offOut" in="SourceGraphic" dx="0" dy="0" />
										<feGaussianBlur result="blurOut" in="offOut" stdDeviation="2" />
										<feBlend in="SourceGraphic" in2="blurOut" mode="normal" />
									</filter>
								</defs>
								
								<path d="M 35 3 L 46 14 M 35 3 L 24 14"   :filter="(node.matrix.level > 0)? 'url(#box-shadow)' : 'none'" :stroke-width="(node.matrix.level > 0) ? 6 : 1" stroke-linecap="square" stroke="#FFC233" fill="none"></path>
								<path d="M 67 35 L 56 24 M 67 35 L 56 46" :filter="(node.matrix.level > 1)? 'url(#box-shadow)' : 'none'" :stroke-width="(node.matrix.level > 1) ? 6 : 1" stroke-linecap="square" stroke="#FFC233" fill="none"></path>
								<path d="M 35 67 L 24 56 M 35 67 L 46 56" :filter="(node.matrix.level > 2)? 'url(#box-shadow)' : 'none'" :stroke-width="(node.matrix.level > 2) ? 6 : 1" stroke-linecap="square" stroke="#FFC233" fill="none"></path>
								<path d="M 3 35 L 14 46 M 3 35 L 14 24"   :filter="(node.matrix.level > 3)? 'url(#box-shadow)' : 'none'" :stroke-width="(node.matrix.level > 3) ? 6 : 1" stroke-linecap="square" stroke="#FFC233" fill="none"></path>
							</svg>
						
							<div class="inner">
								<div class="favicon" :style="{backgroundImage : nodeFavicon(node.data.host)}"></div>
							</div>
						</a>
					</div>
				</div>
			</div>
		</div>
		
		<div class="row-padding col-padding">
			<div class="matrix-rewards orange-gradient">
				<div class="header">
					<div class="uppercase medium lightorange-color align-center">{{getLocale('rewards')}}</div>
				</div>
				
				<div class="content row-padding small-col-padding flex">
					<div v-for="(rewards, index) in rewards_by_level" class="reward-column columns-3 small-col-padding">
						<div class="progress">
							<h3 class="hustle medium center lightestorange-color align-center">{{getLocale('difficulty')}} {{index}}</h3>
						
							<div class="svg-wrapper flex h-center" v-tooltip="'matrix_vairus_explanation'">
								<svg xmlns="http://www.w3.org/2000/svg"  width="120" height="120" viewBox="-20 -20 160 160">
									<filter id="box-shadow" filterUnits="userSpaceOnUse">
										<feOffset result="offOut" in="SourceGraphic" dx="0" dy="0" />
										<feGaussianBlur result="blurOut" in="offOut" stdDeviation="2" />
										<feBlend in="SourceGraphic" in2="blurOut" mode="normal" />
									</filter>
									
									<radialGradient id="orange-gradient">
										<stop offset="10%" stop-color="black" />
										<stop offset="95%" stop-color="#4D2806" />
									</radialGradient>
									
									<circle 
										cx="60" cy="60" 
										r="80" stroke-width="0" fill="url('#orange-gradient')"
									/>
								
									<path 
										fill="none" stroke="black" 
										stroke-width="6" 
										:d="describeArc(0, 359, 60, 0)"
									></path>
									<path 
										fill="none" stroke="#FFC233" 
										filter="url(#box-shadow)"
										stroke-width="6" 
										:d="describeArc(0, (v_progress[index-1]*3.6)/100, 60, 0)"
									></path>
								</svg>
								
								<div class="vairus">
									<div class="percent orange-color">{{Math.floor(v_progress[index-1]/100)}}%</div>
								</div>
							</div>
							
							<div class="text lightestorange-color uppercase align-center row-padding columns-7 center">{{ getLocale('matrix_progress')+' '+rarityByLevel(index-1) }}</div>
						</div>
						
						<div class="rewards">
							<div v-for="n in max_rewards_length">
								<div v-if="rewards.length >= n" class="reward">
									<div class="info small-col-padding small-row-padding">
										<div class="flex">
											<div class="columns-6">
												<div>{{formattedTime(rewards[n-1].time).date}}</div>
												<div>{{formattedTime(rewards[n-1].time).time}}</div>
											</div>
											<div class="columns-6 align-right">
												<div class="uppercase nowrap">{{getLocale('stage_reached')}}</div>
												<div>{{rewards[n-1].stage}}</div>
											</div>
										</div>
									</div>
									
									<div class="materials small-col-padding small-row-padding flex v-center h-center">
										<div class="bytes">
											<div class="icon" :style="{ 'background-image' : getBytesImage() }"></div>
											<div>{{rewards[n-1].bytes.toLocaleString()}}</div>
										</div>
										<div v-for="(value, shard) in rewards[n-1].shards">
											<div class="icon" :style="{ 'background-image' : getShardImage(shard) }"></div>
											<div>{{value}}</div>
										</div>
										<div v-for="(value, key) in rewards[n-1].hkeys">
											<div class="icon" :style="{ 'background-image' : getKeyImage(key) }"></div>
											<div>{{value}}</div>
										</div>
										<div class="vairus" v-if="rewards[n-1].vairus">
											<div  :style="{ 'background-image' : getVairusImage(rewards[n-1].vairus, 'base') }"></div>
										</div>
									</div>
								</div>
								
								<div v-else class="empty-reward"></div>
							</div>	
						</div>
					</div>
				</div>
			</div>
		</div>
		
		<div class="reward-tooltip orange-border orange-gradient align-center" v-if="current_node" :style="tooltipStyle"> 
			<div>{{current_node.data.host}}</div>
			<div>LV{{current_node.matrix.level}}</div>
			<div class="rewards" v-if="completed_today[current_node.data.host]">
				<div class="flex space">
					<div class="uppercase">{{ getLocale('rewards') }}</div>
					<div>Stage {{completed_today[current_node.data.host].stage}}</div>
				</div>
				<div class="material flex">
					<div class="flex bytes">
						<div>{{completed_today[current_node.data.host].bytes.toLocaleString()}}</div>
						<div class="icon" :style="{ 'background-image' : getBytesImage() }"></div>
					</div>
					<div v-for="(value, shard) in completed_today[current_node.data.host].shards" class="flex shards">
						<div>{{value}}</div>
						<div class="icon" :style="{ 'background-image' : getShardImage(shard) }"></div>
					</div>
					<div v-for="(value, key) in completed_today[current_node.data.host].hkeys" class="flex">
						<div>{{value}}</div>
						<div class="icon" :style="{ 'background-image' : getKeyImage(key) }"></div>
					</div>
				</div>
				<div class="align-center">
					<div class="vairus" v-if="completed_today[current_node.data.host].vairus">
						<div :style="{ 'background-image' : getVairusImage(completed_today[current_node.data.host].vairus, 'base') }"></div>
					</div>
				</div>
			</div>
		</div>
	</div>
</template>


<script>
	var browser = browser || chrome;
	import Vue from 'vue';
	import TutorialIcon from '../components/TutorialIcon.vue';
	import { commonMixin } from '../mixins/common.js';
	import { storeGettersMixin } from '../mixins/store_getters.js';
	
	export default {
		data: function () {
			return{
				timezone_offset : new Date().getTimezoneOffset(),
				is_down  :  false,
				startx : '',
				scroll_left : '',
				first_scroll : false,
				current_node : null,
				tooltip : {
					top : 0,
					left : 0
				}
			}
		},
		components: { TutorialIcon },
		computed: {
			current_timezone(){
				let date = new Date(this.current_time);
				return date.getHours().toString().padStart(2,0)+':00';
			},
			node_by_matrix(){
				let node_by_matrix = {};
				
				this.grid_nodes.forEach(function(node){
					if(node.data != null && node.type == 'builder'){
						var matrix = this.matrix_info[node.data.host];
						
						if(typeof matrix != 'undefined'){
							if(!node_by_matrix.hasOwnProperty(matrix.time)){
								node_by_matrix[matrix.time] = [];
							}
							
							node.matrix = this.matrix_info[node.data.host];
							
							node_by_matrix[matrix.time].push(node);
						}
					}
				}.bind(this));
				
				node_by_matrix = Object.keys(node_by_matrix).sort().reduce(
					  (obj, key) => { 
						obj[key] = node_by_matrix[key]; 
						return obj;
					  }, {}
				);
				
				return node_by_matrix;
			},
			rewards_by_level(){
				let rewards = { 1 : [], 2 : [], 3 : [], 4 : [] };
				
				this.matrix_rewards.forEach(function(r){
					rewards[r.level].push(r);
				});
				
				return rewards;
			},
			max_rewards_length(){
				var length = 0;
				for(var level in this.rewards_by_level){
					length = Math.max(length, this.rewards_by_level[level].length);
				}
				return Math.min(4, length);
			},
			completed_today(){
				let completed_today = {};
				let start_of_day = new Date(); 
				start_of_day.setUTCHours(0,0,0,0);
				let start_timestamp = start_of_day.getTime()/1000;
				
				this.matrix_rewards.forEach(function(reward){
					if(reward.time > start_timestamp){
						completed_today[reward.host] = reward;
					}
				});
				return completed_today;
			},
			tooltipStyle(){
				return {
					top : this.tooltip.top+'px', 
					left : this.tooltip.left+'px'
				};
			}
		},
		methods: {
			nodeOver(event, node){
				this.tooltip.top = event.clientY-100;
				this.tooltip.left = event.clientX+10;
				this.current_node  = node;
			},
			nodeLeave(){
				this.current_node = null;
			},
			formattedTime(timestamp){
				let date = new Date(timestamp * 1000);
				return {
					date : date.getDate().toString().padStart(2, '0')+'/'+(date.getMonth()+1).toString().padStart(2, '0')+'/'+date.getFullYear(),
					time : date.getHours().toString().padStart(2, '0')+':'+date.getMinutes().toString().padStart(2, '0')
				};
			},
			rarityByLevel(level){
				switch(level){
					case 0: return this.getLocale('common');
					case 1: return this.getLocale('uncommon');
					case 2: return this.getLocale('rare');
					case 3: return this.getLocale('epic');
				}
			},
		},
		watch: { 
			node_by_matrix: function(newVal, oldVal) {
				//Autoscroll all'orario corrent o all'orario più vicino
				if( Object.keys(newVal).length > 0 && !this.first_scroll){
					this.first_scroll = true;
					
					setTimeout(function(){
						var timezone = this.current_timezone;
						
						//Se non ci sono matrici nell'orario corrent scorro all'orario più vicino
						if(!this.$refs.hasOwnProperty(this.current_timezone)){
							let times = Object.keys(this.$refs);
							
							times.forEach(function(time){
								if(time != 'timeline' && this.current_timezone > time){
									timezone = time;
								}
							}.bind(this));
						}
						if(timezone != '00:00'){
							this.$refs.timeline.scrollLeft = this.$refs[timezone][0].offsetLeft;
						}
					}.bind(this), 0);
				}
			}
		},
		mixins: [commonMixin, storeGettersMixin]
	}
	
</script>


<style lang="scss" scoped>
	@import "../styles/variables";

	.matrix-recap{
		border-radius: 10px;
		background: radial-gradient(ellipse at center, black 0%, rgba(56, 29, 4, 0.8) 100%);
		
		h3{
			padding-bottom: 10px;
		}
		
		.tutorial-icon{
			margin-right: 20px;
			margin-top: 20px;
		}
				
		.wrapper{
			overflow-x: hidden;
			padding-bottom: 20px;
			
			.timeline{
				position: relative;
				width: 100%;
				overflow-x: auto;
				white-space: nowrap;
				transition: all 0.2s;
				
				scrollbar-width: thin;
				scrollbar-color: $darkestorange $black;
				
				&::-webkit-scrollbar {
					width: 8px;
				}
				&::-webkit-scrollbar-track {
					background-color: $black;
				}
				&::-webkit-scrollbar-thumb {
					background-color: $darkestorange;
				}
				
				.timezone{
					display: inline-block;
					margin-bottom: 10px;
					
					.time{
						border: 1px solid $lightestorange;
						border-bottom: none;
						color: $orange;
						padding: 5px;
						user-select: none;
					}
					
					&.past{
						.time{
							border-style: dotted;
							border-bottom: none;
							opacity: 0.5;
						}
						svg, .inner{
							opacity: 0.5;
						}
					}
					
					&.current .time{
						border-top: 3px solid $orange;
						border-left: 3px solid $orange;
						
						&:before{
							content: '';
							background-image: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' width='20' height='20' viewBox='0 0 20 20'%3E%3Cpath id='clock' d='M13,23A10,10,0,1,1,23,13,10,10,0,0,1,13,23Zm8-10a8,8,0,1,0-8,8,8,8,0,0,0,8-8Zm-4-1a1,1,0,0,1,0,2H14a2.006,2.006,0,0,1-2-2V8a1,1,0,0,1,2,0v4Z' transform='translate(-3 -3)' fill='%23FF8800' fill-rule='evenodd'/%3E%3C/svg%3E%0A");
							display: inline-block;
							width: 16px;
							height: 16px;
							background-size: contain;
							margin-right: 5px;
							transform: translateY(1.5px);
						}
					}
					
					.node{
						display: inline-block;
						position: relative;
						width: 70px;
						height: 70px;
						cursor: pointer;
						margin: 10px;
						
						svg{
							position: absolute;
							left: 0;
							top: 0;
						}
						
						.inner{
							padding-top: 100%;
						
							.favicon{
								position: absolute;
								left: 35%;
								top: 35%;
								width: 30%;
								height: 30%;
								background-size: contain;
								pointer-events: none;
							}
						}
						
						&.completed svg path{
							stroke: #00FFB4;
						}
					}
				}
			}	
		}	
				
		.reward-tooltip{
			position: fixed;
			border-radius: 10px;
			padding: 0.5rem;
			
			.rewards{
				margin-top: 0.5rem;
				padding-top: 0.5rem;
				border-top: $orange 1px solid;
				
				.uppercase{
					margin-right: 2rem;
				}
				.material{
					padding: 0.5rem 0;
					
					.bytes,.shards{
						margin-right: 1rem;
					}
				}
			}
			
			.icon{
				width: 20px;
				background-size: contain;
				background-repeat: no-repeat;
				background-position: center;
			}
			.vairus{
				display: inline-block;
				width: 30px;
				height: 30px;
				
				div{
					background-color: white;
					background-size: contain;
					background-repeat: no-repeat;
					background-position: center;
					width: 30px;
					height: 30px;
				}
			}
		}
		
		.matrix-rewards{
			border-radius: 10px;
			
			.header{
				padding: 5px 0;
				background-color: #572C06;
				border-top-left-radius: 10px;
				border-top-right-radius: 10px;
			}
		
			.progress .text{
				height: 80px;
			}
		
			.svg-wrapper{
				position: relative;
				
				.vairus{
					position: absolute;
					left: 50%;
					top: 50%;
					transform: translate(-50%, -50%);
					display: flex;
					justify-content: center;
					align-items: center;
					width: 40px;
					height: 60px;
					border-radius: 5px;
					background-color: black;
					
					.percent{    
						background-color: #333333;
						width: 30px;
						height: 30px;
						border-radius: 50%;
						text-align: center;
						font-size: 0.7rem;
						line-height: 30px;
					}
				}
				
			}
		
			.reward{
				margin-bottom: 20px;
				background-color: black;
				border-radius: 10px;
				box-shadow: 0px 2px 10px 0px rgba(0, 0, 0, 0.3);
				color: #FFDBB3;

				
				.info{
				    flex-grow: 1;
					
					.host{
						margin-bottom: 5px;
						padding-bottom: 5px;
						border-bottom: 1px solid #333333;
					}
				}
				
				.materials{
					background-color: #332C24;
					border-bottom-left-radius: 10px;
					border-bottom-right-radius: 10px;
					height: 80px;
					
					
					> div{
						margin: 0 10px;
						text-align: center;
					}
					
					.icon{
						display: inline-block;
						width: 20px;
						height: 20px;
						margin-bottom: 5px;
						background-size: contain;
						background-repeat: no-repeat;
						background-position: center;
					}
					.vairus{
						display: flex;
						justify-content: center;
						align-items: center;
						width: 40px;
						height: 60px;
						border-radius: 5px;
						background-color: black;
						
						
						div{
							background-color: white;
							background-size: contain;
							background-repeat: no-repeat;
							background-position: center;
							width: 30px;
							height: 30px;
							border-radius: 50%;
						}
					}
				}
				
			}
			
			.empty-reward{
				height: 140px;
				margin-bottom: 20px;
				background-color: black;
				border-radius: 10px;
				background: radial-gradient(ellipse at center, #261204 0%, #1F0E06 100%);
			}
		}
	}
	
	@media screen and (max-width: 1024px) {
		.matrix-rewards .content{
			flex-wrap: wrap;
			
			.reward-column{
				width: 50%;
				margin-bottom: 50px;
			}
		}
	}
	
	@media screen and (max-width: 540px) {
		.matrix-rewards .content{
			.reward-column{
				width: 100%;
				
				.empty-reward{
					display: none;
				}
			}
		}
	}
</style>
